// ==================		messiahCommand.h		==============
//
// Copyright (C) 2002 pmG Worldwide LLC. All Rights Reserved.
//
// ===============================================================
//
// Class Name: messiahCommand
//
// ===============================================================
//
// Class Description:
//
// Implements MEL interaction with the messiahMaya host connection.
//
// Command Name: messiah
//
// Arguments:
//
//		(none):				launch messiah interface
//		-attachXform, -ax:	attach a messiahXform node.
//		-attachDform, -ad:	attach a messiahDform node.
//
// ===============================================================
//
// Version History:
//
// Written By: Ron Griswold
// Date: 4/18/2002
//
// Revised By:
// Date: 
//
// ===============================================================
#ifndef MM_MESSIAHCOMMAND
#define MM_MESSIAHCOMMAND

#include "Params.h"
#include "ErrorCheck.h"

#include <maya/MPxCommand.h>

// ===============================================================
// messiahCommand
// ===============================================================
class messiahCommand : public MPxCommand
{
public:

	enum argFlag	{ MC_HELP			= 0x1,
					  MC_ATTACH_XFORM	= 0x2,
					  MC_ATTACH_DFORM	= 0x4,
					  MC_SET_SCALE		= 0x8,
					  MC_QUERY			= 0x10
	};

	/*CST*/			messiahCommand();
	/*DST*/			~messiahCommand();

	MStatus			parseArgs( const MArgList& args );
	MStatus			doIt( const MArgList& );
	MStatus			redoIt();
	MStatus			undoIt();
	bool			isUndoable() const { return true; }

	static void*	creator();

private:	// command instance data

	unsigned int	_argFlags;
};

#endif