/////////////////////////////////////////////////////////////
// CINEMA SDK : FILTER PLUGINS														 //
/////////////////////////////////////////////////////////////
// VERSION    : CINEMA 4D V6 AMBER												 //
/////////////////////////////////////////////////////////////
// (c) 1989-2001 MAXON Computer GmbH, all rights reserved	 //
/////////////////////////////////////////////////////////////

#ifndef __C4D_FILTERPLUGIN_H
#define __C4D_FILTERPLUGIN_H

#include "ge_math.h"

class _Filename;
class _String;
class BaseContainer;
class BaseDocument;
class BaseBitmap;

#define FILTER3D_OBJECTS					(1<<0)
#define FILTER3D_MATERIALS				(1<<1)
#define FILTER3D_ENVIRONMENT			(1<<2)
#define FILTER3D_DIALOGSALLOWED		(1<<3)
#define FILTER3D_PROGRESSALLOWED	(1<<4)

struct FILTER3DPLUGIN
{
	_String *suffix;

	Bool (*Identify			)(_Filename *name, _BaseContainer *settings, UCHAR *probe, LONG size);
	LONG (*Load					)(_Filename *name, _BaseContainer *settings, BaseDocument *doc, LONG flags, _String *error, Bool *framescene);
	LONG (*Save					)(_Filename *name, _BaseContainer *settings, BaseDocument *doc, LONG flags);
	Bool (*Edit					)(_BaseContainer *settings);
};

struct FILTER2DPLUGIN
{
	_String *suffix;
	Bool		force_suffix;

	Bool (*Identify			)(_Filename *name, UCHAR *probe, LONG size);
	LONG (*Load					)(_Filename *name, BaseBitmap *bm, LONG frame);
	LONG (*Save					)(_Filename *name, BaseBitmap *bm, _BaseContainer *settings, LONG savebits);
	Bool (*Edit					)(_BaseContainer *settings);
	LONG (*GetMaxAlphas	)(_BaseContainer *settings);
};

#endif
