#ifndef FINDDATA_H
#define FINDDATA_H

#include "SystemTime.h"

namespace Win
{

class FindData : public	WIN32_FIND_DATA
{
public:
	bool		IsArchive()		{ return dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE ? true : false; }
	bool		IsCompressed()	{ return dwFileAttributes & FILE_ATTRIBUTE_COMPRESSED ? true : false; }
	bool		IsDirectory()	{ return dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ? true : false; }
	bool		IsEncrypted()	{ return dwFileAttributes & FILE_ATTRIBUTE_ENCRYPTED ? true : false; }
	bool		IsHidden()		{ return dwFileAttributes & FILE_ATTRIBUTE_HIDDEN ? true : false; }
	bool		IsNormal()		{ return dwFileAttributes & FILE_ATTRIBUTE_NORMAL ? true : false; }
	bool		IsOffline()		{ return dwFileAttributes & FILE_ATTRIBUTE_OFFLINE ? true : false; }
	bool		IsReadOnly()	{ return dwFileAttributes & FILE_ATTRIBUTE_READONLY ? true : false; }
	bool		IsSystem()		{ return dwFileAttributes & FILE_ATTRIBUTE_SYSTEM ? true : false; }
	bool		IsTemp()		{ return dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY ? true : false; }

	void		CreateTime(SystemTime &time);
	void		AccessedTime(SystemTime &time);
	void		WriteTime(SystemTime &time);

	int			Size();			
	char const *FileName();		
	char const *ClassicName();	
};

}
#endif