
/*=============================================================================
SCENE LOAD
	1. preload: init logs and buffers
	2. load:
			a. log the modifiers
			b. extract and save the fxs
	3. postload:
			a. log the objects
			b. load the fxs
				- HostManager will copy the object data into the relevant fx_object
			c. reset the logs
				- HostManager will need this to manage the fx_objects

SCENE SAVE
	1. presave:
		a. init logs and buffers
		b. reset logs
	2. save:
		a. save object fxs for the last modifier
			- HostManager will store the object ids in the fxs


==============================================================================*/

// FindNodeReference //////////////////////////////////////////////////////////////////////
/*
		if ( reference_maker->SuperClassID() == GEN_DERIVOB_CLASS_ID ) 
		{
			INode			*node = ( INode * )reference_maker;
			IDerivedObject	*derived_object = ( IDerivedObject *)reference_maker;
			Object			*object = derived_object->GetObjRef();
			int				num_modifiers = derived_object->NumModifiers();
			int				modifier_index;

			if (object)
			{
				for (modifier_index=0; modifier_index<num_modifiers; modifier_index++)
				{
					Modifier *modifier = derived_object->GetModifier( modifier_index );
					ModContext *modifier_context = derived_object->GetModContext( modifier_index );

					if( modifier_context == mod_context ) return node;
				}
			}
		}
*/
////////////////////////////////////////////////////////////////////////////////////////////

// messiahMAX constructor //////////////////////////////////////////////////////////////////
/*
	if (!master_ref_pointers)
	{
		master_ref_pointers = (messiahMAX**)calloc(1,sizeof(messiahMAX*));
	}
	else
	{
		master_ref_pointers = (messiahMAX**)realloc(master_ref_pointers,(num_master_refs+1)*sizeof(messiahMAX*));
	}

	master_ref_pointers[num_master_refs++]=this;
*/
////////////////////////////////////////////////////////////////////////////////////////////

// messiahMAX destructor ///////////////////////////////////////////////////////////////////
/*	int i, j, modifier_exists = 0;

	for (i=0;i<num_master_refs;i++)
	{
		if (master_ref_pointers[i]==this)
		{
			modifier_exists = 1;
			break;
		}
	}

	if (modifier_exists)
	{
		if (num_master_refs>1)
		{
			j = i+1;
			for (i=j;i<num_master_refs;i++)
				master_ref_pointers[i-1] = master_ref_pointers[i];

			num_master_refs--;

			master_ref_pointers = (messiahMAX**)realloc(master_ref_pointers,(num_master_refs)*sizeof(messiahMAX*));
		}
		else
		{
			free(master_ref_pointers);
			master_ref_pointers = NULL;
			num_master_refs=0;
		}
	}
*/
/////////////////////////////////////////////////////////////////////////////////////////////////

// NotifyRefChanged /////////////////////////////////////////////////////////////////////////////
/*	int i;
	//TODO: Add code to handle the various reference changed messages

	if (message==REFMSG_CHANGE)
	{
		if (partID&PART_TOPO) //rebuild the object
		{
			i = 0;
		}
		else if (partID&PART_GEOM) //reset the object and its points
		{
			i = 0;
		}
		else if (partID&PART_MTL)
		{
			i = 0;
		}
	}
	else if (message==REFMSG_NODE_NAMECHANGE)
	{
		i = 0;
	}
	else if (message==REFMSG_TARGET_DELETED)
	{
		i = 0;
	}
*/
///////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////
enum { messiahmax_params };


//TODO: Add enums for various parameters
enum { 
	pb_spin,
};



static ParamBlockDesc2 messiahmax_param_blk ( messiahmax_params, _T("params"),  0, &messiahMAXDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL, IDS_PARAMS, 0, 0, NULL,
/*
	// params
	pb_spin, 			_T("spin"), 		TYPE_FLOAT, 	P_ANIMATABLE, 	IDS_SPIN, 
		p_default, 		0.1f, 
		p_range, 		0.0f,1000.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_EDIT,	IDC_SPIN, 0.01f, 
		end,
*/


	end
	);

/////////////////////////////////////////////////////////////////////////////////////////////////////



/* NOT USED----------------------------------

static INode* FindNodeRef(ReferenceTarget *rt);


static INode* GetNodeRef(ReferenceMaker *rm)
{
	if (rm->SuperClassID()==BASENODE_CLASS_ID) return (INode *)rm;

	if (rm->IsRefTarget())
	{
		return FindNodeRef((ReferenceTarget *)rm);
	}

	return NULL;
}

static INode* FindNodeRef(ReferenceTarget *rt)
{
	DependentIterator di(rt);

	ReferenceMaker	*rm;
	INode			*nd = NULL;

	while (rm=di.Next())
	{	
		nd = GetNodeRef(rm);
		if (nd) return nd;
	}

	return NULL;
}

*/

/*
//Find the node corresponding to the modifier and modcontext
void LogNodeData( ReferenceTarget *modifier, ReferenceTarget  *o_modifier, int *counter) 
{
	DependentIterator	di( modifier );
	ReferenceMaker		*reference_maker;

	while ( reference_maker = di.Next() ) 
	{
		if ( reference_maker->SuperClassID() == GEN_DERIVOB_CLASS_ID ) 
		{
			IDerivedObject	*derived_object = ( IDerivedObject *)reference_maker;
			Object			*object = derived_object->GetObjRef();
			int				num_modifiers = derived_object->NumModifiers();
			int				modifier_index;

			for (modifier_index=0; modifier_index<num_modifiers; modifier_index++)
			{
				Modifier	*modifier = derived_object->GetModifier( modifier_index );
				ModContext	*mc = derived_object->GetModContext( modifier_index );
				FX_NodeLog	*nl = NULL;

				//if( modifier_context == mod_context ) return node;
				if( modifier == o_modifier)
				{
					messiahData		*m_data=NULL;
					void			*fx_obj = NULL;

					if (mc)
					{
						if (!mc->localData)
						{
							mc->localData = (LocalModData*)new messiahData;
							m_data = (messiahData*)mc->localData;
							m_data->messiah_object = NULL;
						}

						m_data = (messiahData*)mc->localData;
						fx_obj = m_data->messiah_object;
					}

					//return node...................................................
					nl = nodeLogElement(o_modifier, object, mc, fx_obj);

					if (!fx_obj)
					{
						if (counter)
						{
							nl->load_ID = *counter;
							*counter = *counter + 1;
						}
					}
				}
			} 
		}

		if( reference_maker->IsRefTarget() )
		{
			LogNodeData( ( ReferenceTarget*)reference_maker, o_modifier, counter);
		}
	}

	return;
}


int CollectModifiers(INode *node, int flags)
{
 	ReferenceMaker		*rm = (ReferenceMaker*)node;
	int					counter = 0;

	if ( rm->SuperClassID() == GEN_DERIVOB_CLASS_ID ) 
	{
		IDerivedObject	*derived_object = ( IDerivedObject *)rm;
		int				modifier_index;
		int				num_modifiers = derived_object->NumModifiers();
		int				i, modifier_exists = 0;

		for (modifier_index=0; modifier_index<num_modifiers; modifier_index++)
		{
			Modifier	*modifier = derived_object->GetModifier( modifier_index );
			ModContext	*modifier_context = derived_object->GetModContext( modifier_index );

			modifier_exists = 0;

			if (modifier) //there is a max bug that can return bad data
			{
				if( modifier->SuperClassID() == OSM_CLASS_ID)
				{
					if (modifier->ClassID() == MESSIAHMAX_CLASS_ID)
					{
						if (flags&1)
						{
							if (!loaded_ref_pointers)
							{
								num_loaded_refs = 0;
								loaded_ref_pointers = (messiahMAX**)calloc(1,sizeof(messiahMAX*));
							}
							else
							{
								for (i=0;i<num_loaded_refs;i++)
								{
									if (loaded_ref_pointers[i]==(messiahMAX*)modifier)
									{
										modifier_exists = 1;
										break;
									}
								}

								if (modifier_exists) continue;

								loaded_ref_pointers = (messiahMAX**)realloc(loaded_ref_pointers,(num_loaded_refs+1)*sizeof(messiahMAX*));
							}

							loaded_ref_pointers[num_loaded_refs++]=(messiahMAX*)modifier;
						}
						else if (flags&2)
						{
							if (!saved_ref_pointers)
							{
								num_saved_refs = 0;
								saved_ref_pointers = (messiahMAX**)calloc(1,sizeof(messiahMAX*));
							}
							else
							{
								for (i=0;i<num_saved_refs;i++)
								{
									if (saved_ref_pointers[i]==(messiahMAX*)modifier)
									{
										modifier_exists = 1;
										break;
									}
								}

								if (modifier_exists) continue;

								saved_ref_pointers = (messiahMAX**)realloc(saved_ref_pointers,(num_saved_refs+1)*sizeof(messiahMAX*));
							}

							saved_ref_pointers[num_saved_refs++]=(messiahMAX*)modifier;
						}

						counter++;
					}
				}
			}
		}
	}

	// recurse children
	for(int i = 0; i < node->NumberOfChildren(); i++)
	{
		counter += CollectModifiers(node->GetChildNode(i), flags);
	}

	return counter;
}
*/

/*************************************************************************************************
*
	Between NotifyPreCollapse and NotifyPostCollapse, Modify is
	called by the system.  NotifyPreCollapse can be used to save any plugin dependant data e.g.
	LocalModData
*
\*************************************************************************************************/
/*************************************************************************************************
*
	NotifyPostCollapse can be used to apply the modifier back onto to the stack, copying over the
	stored data from the temporary storage.  To reapply the modifier the following code can be 
	used

	Object *bo = node->GetObjectRef();
	IDerivedObject *derob = NULL;
	if(bo->SuperClassID() != GEN_DERIVOB_CLASS_ID)
	{
		derob = CreateDerivedObject(obj);
		node->SetObjectRef(derob);
	}
	else
		derob = (IDerivedObject*) bo;

	// Add ourselves to the top of the stack
	derob->AddModifier(this,NULL,derob->NumModifiers());

*
\*************************************************************************************************/

/*************************************************************************************************
*
	ModifyObject will do all the work in a full modifier
    This includes casting objects to their correct form, doing modifications
	changing their parameters, etc
*
\************************************************************************************************/
